unit DE42u2;

(*A general purpose dialog to return a date, in Delphi coding
(i.e. the code for 1 Jan 1996 is 35,065, under Delphi 2 and higher.
(I half remember that in Delphi version 1, the base date was
different))

The date will be in wDateFromDE42DateInput when the dialog closes.

The dialog should be called from other programs with...

DD                                        *)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DE42u1, ComCtrls, ExtCtrls;

type
  TDE42DateInputf1 = class(TForm)
    Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    eDay: TEdit;
    eMonth: TEdit;
    eYear: TEdit;
    UpDown1: TUpDown;
    eDaysBefore: TEdit;
    buDoByDaysBefore: TButton;
    buDoByDate: TButton;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure buDoByDaysBeforeClick(Sender: TObject);
    procedure buDoByDateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    wDateFromDE42DateInput:word;
  end;

var
  DE42DateInputf1: TDE42DateInputf1;

implementation

{$R *.DFM}

procedure TDE42DateInputf1.FormCreate(Sender: TObject);
begin
top:=(screen.height div 3)-(clientheight div 2)+50;
left:=(screen.width div 2)-(clientwidth div 2)+50;
BorderStyle:=bsDialog;
BorderIcons:=[];
Caption:='Specify a Date';
end;

procedure TDE42DateInputf1.UpDown1Click(Sender: TObject;
  Button: TUDBtnType);
begin
eDaysBefore.text:=inttostr(UpDown1.position);
end;

procedure TDE42DateInputf1.buDoByDaysBeforeClick(Sender: TObject);
begin
wDateFromDE42DateInput:=trunc(now)-UpDown1.position;
(*"Now" is a built in Delphi function.
  int(now) gives me the date, in Delphi's coding.
  See the place where wDate was declared for more information

  There is also a "Date" function, which would have been even
  more suitable... but I forgot it was available!*)
close;
end;

procedure TDE42DateInputf1.buDoByDateClick(Sender: TObject);
var bDay,bMonth:byte;
wYear:word;
iErr:integer;
boExit:boolean;
begin
val(eDay.text,bDay,iErr);
if iErr<>0 then bDay:=0;
val(eMonth.text,bMonth,iErr);
if iErr<>0 then bMonth:=0;
val(eYear.text,wYear,iErr);
if iErr<>0 then wYear:=0;
//showmessage(inttostr(bDay)+' '+inttostr(bMonth)+' '+inttostr(wYear));
if (length(eYear.text)<>4) or
   (bDay<1) or
   (bMonth<1) or
   (wYear<1) or
   (bDay>31) or
   (bMonth>12) or
   (wYear>9998)
   (*If day =30 when month=Feb, an EConvertError will arise, and
     the try... except... will prevent the dialog from closing.
     Some of the things I've explicitly trapped could probably
     also be dealt with by that.*)
   then begin
   //showmessage(invalid value)
     end//no ; here
   else begin
     boExit:=true;
     try
     wDateFromDE42DateInput:=trunc(EncodeDate(wYear, bMonth, bDay));
        //trunc to change from DateTime data type, with fractional .000
     except on EConvertError do boExit:=false;
     end;//try.. except
     if boExit then close;
     end;//else;
end;

end.
